#include <cstdio>
#include <vector>
#include <algorithm>

typedef unsigned int uint32;

struct light
{
	long x, y, start, end;
	bool operator<(const light& other)
	{
		return start < other.start;
	}
};

inline bool isLit(light* l, long coord)
{
	return (coord > l->start && coord < l->end);
}
int main(int argc, char** argv)
{
	uint32 n = 0;
	scanf("%u", &n);
	std::vector<light> lights(n), lightsE(n);
	long min = 0, max = 0;
	for (uint32 i = 0; i < n; ++i)
	{
		long x, y;
		scanf("%u %u", &x, &y);
		(y<0?y=-y:0);
		light k;
		k.x = x, k.y = y;
		k.start = x - y, k.end = x + y;
		lights[i] = k;

		if (i == 0)
			min = x - y, max = x + y;
		else
		{
			if (x-y < min) min = x - y;
			if (x+y > max) max = x + y;
		}
	}

	std::sort(lights.begin(), lights.end());

	uint32 maxLights = 0;
	uint32 closestLight = 0;

	for (uint32 i = 0; i < lights.size(); ++i)
	{
		light& l = lights[i];
		for (uint32 j = l.start + 1; j <= l.end; ++j)
		{
			uint32 litBy = 1;
			uint32 k = i+1;
			uint32 l1idx = 0;
			while (k < lights.size() && lights[k].start < j)
			{
				if (isLit(&lights[k], j)) ++l1idx;
				++k;
			}
			uint32 m = i-1;
			uint32 l2idx = 0;
			if (i>0)
			{
				while (m > 0 && lights[m].end > j)
				{
					if (isLit(&lights[m], j)) ++l2idx;
					--m;
				}
			} else m = 0;
			litBy += l1idx+l2idx;
			if (litBy > maxLights)
				maxLights = litBy;
		}
	}

	printf("%u", maxLights);

	return 0;
}